local ADDON, Table = ...

WeekFrame = CreateFrame('Frame', 'WeekFrame', UIParent,"BasicFrameTemplateWithInset")
tinsert(UISpecialFrames, "WeekFrame")
local L = WeekKeys.L
WeekVersion = "1.5.5"
WeekFrame:SetSize(500,500)
WeekFrame:SetPoint("center")
WeekFrame.AddonName = WeekFrame:CreateFontString(nil , "BORDER", "GameFontNormal")
WeekFrame.AddonName:SetPoint("top",0,-5)
WeekFrame.AddonName:SetText("|cffffff00WeekKeys   " .. WeekVersion)
WeekFrame:Show()
WeekFrame.ButtonID = 0
WeekFrame.ButtonCount = 0
WeekFrame.Buttons = {}
WeekFrame.Corrupt = {}
WeekFrame.myKeys = {}
WeekFrame.gButtons = {}
WeekFrame.pButtons = {}
WeekFrame.fButtons = {}
WeekFrame.ClassBtn = {}
WeekFrame.SpecBtn = {}
WeekFrame.LootBtn = {}
WeekFrame.SlotBtn = {}
WeekFrame.Mother = {}
WeekFrame.CorruptLinks = {}
WeekFrame.BattleTags = {}
WeekFrame:SetMovable(true)
WeekFrame:RegisterForDrag("LeftButton")
SLASH_WK1 = '/wk'
function SlashCmdList.WK(msg, editbox)
    if string.lower(msg) == "hide" then
        WeekKeys.icon:Hide("WeekKeys")
        WeekKeys.addon.db.profile.minimap.hide = true
    elseif string.lower(msg) == "show" then
        WeekKeys.icon:Show("WeekKeys")
        WeekKeys.addon.db.profile.minimap.hide = false
    else
        kPlayer:Save()
        if WeekFrame.ButtonID == 0 then
            wChooses()
        end
        WeekFrame:SetShown(not WeekFrame:IsShown())
    end
end
WeekFrame:SetScript("OnMouseDown", function(self, button)
    if button == "LeftButton" and not self.isMoving then
        self.isMoving = true;
        self:StartMoving();
    end
end)

WeekFrame:SetScript("OnMouseUp", function(self, button)
    if button == "LeftButton" and self.isMoving then
        self:StopMovingOrSizing();
        self.isMoving = false;

        local point, _, _, xOfs, yOfs = WeekFrame:GetPoint()

        WeekKeysDB["MainFramePos"] = {
            ["point"] = point,
            ["xOfs"] = xOfs,
            ["yOfs"] = yOfs,
        }
    end
end)
WeekFrame:SetScript("OnHide", function(self)
    if ( self.isMoving ) then
        self:StopMovingOrSizing();
        self.isMoving = false;
    end
end)
WeekFrame.ScrollFrame = CreateFrame("Scrollframe",nil , WeekFrame,"UIPanelScrollFrameTemplate")
WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -80);
WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
WeekFrame.ScrollFrame:SetClipsChildren(true);

WeekFrame.ScrollFrame.ScrollBar:ClearAllPoints();
WeekFrame.ScrollFrame.ScrollBar:SetPoint("TOPLEFT", WeekFrame.ScrollFrame, "TOPRIGHT", -12, -18);
WeekFrame.ScrollFrame.ScrollBar:SetPoint("BOTTOMRIGHT", WeekFrame.ScrollFrame, "BOTTOMRIGHT", -7, 23  );

WeekFrame.ScrollFrame:SetScript("OnMouseWheel", function(self, delta)
	local newValue = self:GetVerticalScroll() - (delta * 20);

	if (newValue < 0) then
		newValue = 0;
	elseif (newValue > self:GetVerticalScrollRange()) then
		newValue = self:GetVerticalScrollRange();
	end

	self:SetVerticalScroll(newValue);
end);

WeekFrame.CorruptNames = {
    [177973] = 315544,
	[177974] = 315545,
	[177975] = 315546, -- haste%
    [177992] = 315554,
	[177993] = 315557,
	[177994] = 315558, -- crit%
    [177986] = 315529,
	[177987] = 315530,
	[177988] = 315531, -- mastery%
    [178010] = 315549,
	[178011] = 315552,
	[178012] = 315553, -- versality%

    [177989] = 318266,
	[177990] = 318492,
	[177991] = 318496, -- haste proc
    [177955] = 318268,
	[177965] = 318493,
	[177966] = 318497, -- crit proc
    [177978] = 318269,
	[177979] = 318494,
	[177980] = 318498, -- mastery proc
    [178001] = 318270,
	[178002] = 318495,
	[178003] = 318499, -- versality proc

    [177998] = 315277,
	[177999] = 315281,
	[178000] = 315282, -- crit modifier
    [177995] = 315590,
	[177996] = 315591,
	[177997] = 315592, -- leech
    [177970] = 315607,
	[177971] = 315608,
	[177972] = 315609, -- avoidance

    [177983] = 318274,
	[177984] = 318487,
	[177985] = 318488, -- inf. stars
    [178004] = 318276,
	[178005] = 318477,
	[178006] = 318478, -- twilight
    [177969] = 318280,
	[177968] = 318485,
	[177967] = 318486, -- echo
    [178007] = 318481,
	[178008] = 318482,
	[178009] = 318483, -- mind flay
    [178013] = 318286,
	[178014] = 318479,
	[178015] = 318480, -- void ritual

    [177981] = 318303,
	[177982] = 318484, -- cooldowns

    [177977] = 318272, -- bleed
    [177976] = 315573 -- 3 sec cd
}

local corruptlist = {--table
    {-- 1.week(1)
        {177981,3300},
        {177978,4125},
        {177999,4125},
        {177987,4125},
        {178009,13200},
        {177975,5000}
    },
    {
        {177986,3000},
        {178013,4125},
        {177965,5000},
        {177996,6300},
        {177982,6750},
        {178012,5000},
        {177971,3300}
    },
    {
        {177983,5000},
        {178001,4125},
        {177976,4125},
        {177993,4125},
        {177991,7875},
        {177997,9000},
        {177972,4250}
    },
    {
        {177992,3000},
        {177995,4250},
        {177974,4125},
        {178005,10000},
        {177980,7875},
        {178000,5000}
    },
    {
        {177973,3000},
        {178007,3000},
        {177990,5000},
        {177968,7875},
        {177985,15000},
        {177994,5000}
    },
    {
        {177989,4125},
        {177988,5000},
        {177998,3000},
        {178014,7875},
        {177970,2400},
        {178002,5000},
        {178006,15000},
    },
    {
        {177969,6250},
        {178010,3000},
        {177979,5000},
        {177984,10000},
        {177966,7875},
        {178015,13200},
        {177977,4125}
    },
    {
        {178004,6250},
        {178003,7875},
        {177967,12000},
        {177955,4125},
        {178011,4125},
        {178008,7875}
    },
}

local list = {
    177973,177974,177975, -- haste%
    177992,177993,177994, -- crit%
    177986,177987,177988, -- mastery%
    178010,178011,178012, -- versality%

    177989,177990,177991, -- haste proc
    177955,177965,177966, -- crit proc
    177978,177979,177980, -- mastery proc
    178001,178002,178003, -- versality proc

    177998,177999,178000, -- crit modifier
    177995,177996,177997, -- leech
    177970,177971,177972, -- avoidance

    177983,177984,177985, -- inf. stars
    178004,178005,178006, -- twilight
    177969,177968,177967, -- echo
    178007,178008,178009, -- mind flay
    178013,178014,178015, -- void ritual

    177981,177982, -- cooldowns

    177977, -- bleed
    177976  -- 3 sec cd
}
for _, value in pairs(list) do
    local _,itemlink = GetItemInfo(value)
    WeekFrame.CorruptNames[value] = GetSpellInfo(WeekFrame.CorruptNames[value])
    WeekFrame.CorruptLinks[value] = itemlink or ""
end
function WeekFrame.WPDropDownDemo_Menu1(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg2 = 0
    info.func = LootFinder.SetStat
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT","ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
    info.text,info.arg1, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat1
    UIDropDownMenu_AddButton(info)
end

function WeekFrame.WPDropDownDemo_Menu2(frame, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    info.text = OPTIONAL
    info.arg1 = 0
    info.func = LootFinder.SetStat
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_STRENGTH,"ITEM_MOD_STRENGTH_SHORT", "ITEM_MOD_STRENGTH_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_AGILITY,"ITEM_MOD_AGILITY_SHORT", "ITEM_MOD_AGILITY_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = SPEC_FRAME_PRIMARY_STAT_INTELLECT,"ITEM_MOD_INTELLECT_SHORT", "ITEM_MOD_INTELLECT_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_CRITICAL_STRIKE,"ITEM_MOD_CRIT_RATING_SHORT", "ITEM_MOD_CRIT_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_HASTE,"ITEM_MOD_HASTE_RATING_SHORT", "ITEM_MOD_HASTE_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_VERSATILITY,"ITEM_MOD_VERSATILITY", "ITEM_MOD_VERSATILITY" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
    info.text,info.arg2, info.checked = STAT_MASTERY,"ITEM_MOD_MASTERY_RATING_SHORT", "ITEM_MOD_MASTERY_RATING_SHORT" == LootFinder.stat2
    UIDropDownMenu_AddButton(info)
end


WeekFrame.ButtonFrame = CreateFrame('Frame', nil, WeekFrame ,"InsetFrameTemplate")
WeekFrame.ButtonFrame:SetSize(150,200)
WeekFrame.ButtonFrame:SetPoint("TOPRIGHT",150,0)

function WeekFrame:AddButton(ButtonText,LabelArray)
    WeekFrame.ButtonCount = WeekFrame.ButtonCount + 1
    local button = CreateFrame('Button', name, WeekFrame.ButtonFrame, 'InsetFrameTemplate2')
    button:SetID(WeekFrame.ButtonCount)
    --print(button:GetID())
    WeekFrame.Buttons[WeekFrame.ButtonCount] = LabelArray
    WeekFrame.ButtonFrame:SetSize(WeekFrame.ButtonFrame:GetWidth(),WeekFrame.ButtonCount * 35 + 5)
    --button
    local texture = button:CreateTexture('textureName', 'BACKGROUND')
    texture:SetPoint('TOPLEFT', 2, -2)
    texture:SetPoint('bottomright', -2, 2)
    texture:SetColorTexture(0.2, 0.2, 0.2, 1)
    button:SetHighlightTexture(texture)
    button:DisableDrawLayer("BORDER")
    button:SetNormalFontObject('GameFontNormal')
    button:SetSize(145, 35)
    button:SetText(ButtonText)
    button:SetPoint("TOPLEFT",2,-(WeekFrame.ButtonCount-1)*35-2)
    button:SetScript("OnClick",function(self)
        -- hide scrollframe
        local scrollChild = WeekFrame.ScrollFrame:GetScrollChild();
	    if (scrollChild) then
		    scrollChild:Hide();
        end
        -- hide previous ?section? elements
        for i,v in ipairs(WeekFrame.Buttons[WeekFrame.ButtonID]) do
            if i ~= 1 then
                v:Hide()
            end
        end
        --set new scrollframe
        WeekFrame.ScrollFrame:SetScrollChild(WeekFrame.Buttons[self:GetID()][1])
        WeekFrame.Buttons[self:GetID()][1]:Show()
        -- show this ?section? elements
        for i,v in ipairs(WeekFrame.Buttons[self:GetID()]) do
            if i ~= 1 then
                v:Show()
            end
        end
        WeekFrame.ButtonID = self:GetID()
    end)
end

WeekKeys.iconStr = {
    [177981] = "|Tinterface/Icons/INV_Wand_1H_NzothRaid_D_01:20:20|t",
    [177982] = "|Tinterface/Icons/INV_Wand_1H_NzothRaid_D_01:20:20|t",
    [177978] = "|Tinterface/Icons/Spell_Nature_FocusedMind:20:20|t",
    [177979] = "|Tinterface/Icons/Spell_Nature_FocusedMind:20:20|t",
    [177980] = "|Tinterface/Icons/Spell_Nature_FocusedMind:20:20|t",
    [177998] = "|Tinterface/Icons/Achievement_Profession_Fishing_FindFish:20:20|t",
    [177999] = "|Tinterface/Icons/Achievement_Profession_Fishing_FindFish:20:20|t",
    [178000] = "|Tinterface/Icons/Achievement_Profession_Fishing_FindFish:20:20|t",
    [177986] = "|TInterface/Icons/Ability_Rogue_SinisterCalling:20:20|t",
    [177987] = "|TInterface/Icons/Ability_Rogue_SinisterCalling:20:20|t",
    [177988] = "|TInterface/Icons/Ability_Rogue_SinisterCalling:20:20|t",
    [178007] = "|TInterface/Icons/Achievement_Boss_YoggSaron_01:20:20|t",
    [178008] = "|TInterface/Icons/Achievement_Boss_YoggSaron_01:20:20|t",
    [178009] = "|TInterface/Icons/Achievement_Boss_YoggSaron_01:20:20|t",
    [177973] = "|TInterface/Icons/Ability_Mage_NetherWindPresence:20:20|t",
    [177974] = "|TInterface/Icons/Ability_Mage_NetherWindPresence:20:20|t",
    [177975] = "|TInterface/Icons/Ability_Mage_NetherWindPresence:20:20|t",
    [177983] = "|TInterface/Icons/Ability_Druid_Starfall:20:20|t",
    [177984] = "|TInterface/Icons/Ability_Druid_Starfall:20:20|t",
    [177985] = "|TInterface/Icons/Ability_Druid_Starfall:20:20|t",
    [178013] = "|TInterface/Icons/Spell_Shadow_Shadesofdarkness:20:20|t",
    [178014] = "|TInterface/Icons/Spell_Shadow_Shadesofdarkness:20:20|t",
    [178015] = "|TInterface/Icons/Spell_Shadow_Shadesofdarkness:20:20|t",
    [177955] = "|TInterface/Icons/Ability_Hunter_RaptorStrike:20:20|t",
    [177965] = "|TInterface/Icons/Ability_Hunter_RaptorStrike:20:20|t",
    [177966] = "|TInterface/Icons/Ability_Hunter_RaptorStrike:20:20|t",
    [177995] = "|TInterface/Icons/Spell_Shadow_LifeDrain02_purple:20:20|t",
    [177996] = "|TInterface/Icons/Spell_Shadow_LifeDrain02_purple:20:20|t",
    [177997] = "|TInterface/Icons/Spell_Shadow_LifeDrain02_purple:20:20|t",
    [178010] = "|TInterface/Icons/Spell_Arcane_ArcaneTactics:20:20|t",
    [178011] = "|TInterface/Icons/Spell_Arcane_ArcaneTactics:20:20|t",
    [178012] = "|TInterface/Icons/Spell_Arcane_ArcaneTactics:20:20|t",
    [177970] = "|TInterface/Icons/spell_warlock_demonsoul:20:20|t",
    [177971] = "|TInterface/Icons/spell_warlock_demonsoul:20:20|t",
    [177972] = "|TInterface/Icons/spell_warlock_demonsoul:20:20|t",
    [178001] = "|TInterface/Icons/Ability_Hunter_OneWithNature:20:20|t",
    [178002] = "|TInterface/Icons/Ability_Hunter_OneWithNature:20:20|t",
    [178003] = "|TInterface/Icons/Ability_Hunter_OneWithNature:20:20|t",
    [177976] = "|TInterface/Icons/ability_warlock_soulswap:20:20|t",
    [177992] = "|TInterface/Icons/Ability_Priest_ShadowyApparition:20:20|t",
    [177993] = "|TInterface/Icons/Ability_Priest_ShadowyApparition:20:20|t",
    [177994] = "|TInterface/Icons/Ability_Priest_ShadowyApparition:20:20|t",
    [177989] = "|TInterface/Icons/Ability_Warrior_BloodFrenzy:20:20|t",
    [177990] = "|TInterface/Icons/Ability_Warrior_BloodFrenzy:20:20|t",
    [177991] = "|TInterface/Icons/Ability_Warrior_BloodFrenzy:20:20|t",
    [178004] = "|TInterface/Icons/Spell_Priest_VoidSear:20:20|t",
    [178005] = "|TInterface/Icons/Spell_Priest_VoidSear:20:20|t",
    [178006] = "|TInterface/Icons/Spell_Priest_VoidSear:20:20|t",
    [177969] = "|TInterface/Icons/Ability_Priest_VoidEntropy:20:20|t",
    [177968] = "|TInterface/Icons/Ability_Priest_VoidEntropy:20:20|t",
    [177967] = "|TInterface/Icons/Ability_Priest_VoidEntropy:20:20|t",
    [177977] = "|TInterface/Icons/Ability_IronMaidens_CorruptedBlood:20:20|t",
}



WeekKeys.CorruptionTier = {
    [177981] = "T1",
    [177982] = "T2",
    [177978] = "T1",
    [177979] = "T2",
    [177980] = "T3",
    [177998] = "T1",
    [177999] = "T2",
    [178000] = "T3",
    [177986] = "T1",
    [177987] = "T2",
    [177988] = "T3",
    [178007] = "T1",
    [178008] = "T2",
    [178009] = "T3",
    [177973] = "T1",
    [177974] = "T2",
    [177975] = "T3",
    [177983] = "T1",
    [177984] = "T2",
    [177985] = "T3",
    [178013] = "T1",
    [178014] = "T2",
    [178015] = "T3",
    [177955] = "T1",
    [177965] = "T2",
    [177966] = "T3",
    [177995] = "T1",
    [177996] = "T2",
    [177997] = "T3",
    [178010] = "T1",
    [178011] = "T2",
    [178012] = "T3",
    [177970] = "T1",
    [177971] = "T2",
    [177972] = "T3",
    [178001] = "T1",
    [178002] = "T2",
    [178003] = "T3",
    [177976] = "T1",
    [177992] = "T1",
    [177993] = "T2",
    [177994] = "T3",
    [177989] = "T1",
    [177990] = "T2",
    [177991] = "T3",
    [178004] = "T1",
    [178005] = "T2",
    [178006] = "T3",
    [177969] = "T1",
    [177968] = "T2",
    [177967] = "T3",
    [177977] = "T1",
}

function wChooses()
    WeekFrame.ButtonID = 1
------------------------ mykeys ---------------------------------
    do
        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame',nil,WeekFrame.ScrollFrame)
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        WeekFrame.ScrollFrame:SetScrollChild(arrayOfElements[1])
       -- arrayOfElements[1]:Show()
        local i = 0
        -- create button for each character, what displays info about character
        for id,data in pairs(WeekKeysDB.Character) do
            -- b -> button
            local bPlayer = CreateFrame('button', 'frameName', arrayOfElements[1], 'InsetFrameTemplate2')
            bPlayer.pos = i + 1
            bPlayer:SetID(id)
            local texture = bPlayer:CreateTexture('textureName', 'BACKGROUND')
            texture:SetPoint('TOPLEFT', 2, -2)
            texture:SetPoint('bottomright', -2, 2)
            texture:SetColorTexture(0.2, 0.2, 0.2, 1)
            bPlayer:SetHighlightTexture(texture)
            bPlayer:DisableDrawLayer("BORDER")
            bPlayer:SetNormalFontObject('GameFontNormal')
            bPlayer:SetSize(WeekFrame:GetWidth()-8, 20)
            bPlayer:SetPoint("TOPLEFT",4,-i*20)
            bPlayer.faction = bPlayer:CreateFontString(nil , 'ARTWORK', "GameFontNormal")
            bPlayer.faction:SetPoint("LEFT", 0,-2)
            if WeekKeysDB.Character[id].faction == "Alliance" then 
                bPlayer.faction:SetText("|Tinterface/groupframe/ui-group-pvp-alliance.blp:20:20|t")
            else
                bPlayer.faction:SetText("|Tinterface/battlefieldframe/battleground-horde.blp:20:20|t")
            end

            bPlayer.name = bPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            bPlayer.name:SetPoint("LEFT",20,0)
            if data.realm == kPlayer.realm then
                bPlayer.name:SetText(WeekKeysDB.Character[id].colored)
            else
                bPlayer.name:SetText(WeekKeysDB.Character[id].colored.." (*)")
            end

            bPlayer.ilvl = bPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            bPlayer.ilvl:SetPoint("LEFT",180,0)
            bPlayer.ilvl:SetText(WeekKeysDB.Character[id].ilvl)

            bPlayer.record = bPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            bPlayer.record:SetPoint("LEFT",240,0)
            bPlayer.record:SetText(WeekKeysDB.Character[id].record)

            bPlayer.kname = bPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            bPlayer.kname:SetPoint("LEFT",290,0)
            if WeekKeysDB.Character[id].keyID then
                if WeekKeysDB.Character[id].keyID == 370 or WeekKeysDB.Character[id].keyID == 369 then
                    local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Character[id].keyID)
                    local operation, mechagon = strsplit(" ", name ,2)
                    bPlayer.kname:SetText("|cffffffff"..mechagon .. " ("..WeekKeysDB.Character[id].keyLevel..")")
                else
                    local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Character[id].keyID)
                    bPlayer.kname:SetText("|cffffffff"..name .. " ("..WeekKeysDB.Character[id].keyLevel..")")
                end
            end

            if WeekKeysDB.Character[id].reward then
                bPlayer.rew = bPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                bPlayer.rew:SetPoint("RIGHT",-30,0)
                bPlayer.rew:SetText("|Tinterface/worldmap/treasurechest_64.blp:20:20|t")
            end
           -- if WeekKeysDB.Character[id].keyID then
           --     local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Character[id].keyID)
           --     bPlayer.name:SetText("|cffffffff"..name .. " ("..WeekKeysDB.Character[id].keyLevel..")")
           -- end
            bPlayer:SetScript("OnClick",function(self)
                if IsShiftKeyDown() then
                    tremove(WeekKeysDB.Character,num)
                    tremove(WeekFrame.myKeys,self.pos)
                    self:Hide()
                  --  WeekKeysDB.Character[num] = nil
                 --   WeekFrame.myKeys[self.pos] = nil

                    for k,v in pairs(WeekFrame.myKeys) do
                        v:SetPoint("TOPLEFT",4,-(k-1)*20)
                        v.pos = k
                    end
                end
            end)
            if id == kPlayer.ID then
                bPlayer:SetID(id)
                bPlayer:SetScript("OnShow",function(self)
                    kPlayer:GetAllData()
                    kPlayer:Save()
                    local ID = self:GetID()
                    self.ilvl:SetText(WeekKeysDB.Character[ID].ilvl)
                    self.record:SetText(WeekKeysDB.Character[ID].record)
                    if WeekKeysDB.Character[ID].keyID then
                        if WeekKeysDB.Character[ID].keyID == 370 or WeekKeysDB.Character[ID].keyID == 369 then
                            local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Character[ID].keyID)
                            local operation, mechagon = strsplit(" ", name ,2)
                            self.kname:SetText("|cffffffff"..mechagon .. " ("..WeekKeysDB.Character[ID].keyLevel..")")
                        else
                            local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Character[ID].keyID)
                            self.kname:SetText("|cffffffff"..name .. " ("..WeekKeysDB.Character[ID].keyLevel..")")
                        end
                    end
                    if self.rew and not C_MythicPlus.IsWeeklyRewardAvailable() then
                        self.rew:SetText("")
                    end
                end)
                bPlayer:SetScript("OnClick",nil)
            end
            tinsert(WeekFrame.myKeys,bPlayer)
            i = i + 1
        end

        arrayOfElements[2] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[2]:SetPoint("TOPLEFT", 20,-60)
        arrayOfElements[2]:SetText(CHARACTER_NAME_PROMPT)

        arrayOfElements[3] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[3]:SetPoint("TOPLEFT", 180,-60)
        arrayOfElements[3]:SetText(ITEM_LEVEL_ABBR)

        arrayOfElements[4] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[4]:SetPoint("TOPLEFT", 230,-60)
        local record,_ = strsplit(":",MYTHIC_PLUS_BEST_WEEKLY)
        arrayOfElements[4]:SetText(record)

        arrayOfElements[5] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[5]:SetPoint("TOPLEFT", 310,-60)
        local keystone,_ = strsplit(":",CHALLENGE_MODE_KEYSTONE_NAME)
        arrayOfElements[5]:SetText(keystone)

        WeekFrame:AddButton(L["mykeys"],arrayOfElements)
    end
-------------------------- party keys ------------------------------------------
    do

        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame',nil,WeekFrame.ScrollFrame)
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        arrayOfElements[1].count = 0

        arrayOfElements[2] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[2]:SetPoint("TOPLEFT", 20,-60)
        arrayOfElements[2]:SetText(CHARACTER_NAME_PROMPT)
        arrayOfElements[2]:Hide()

        arrayOfElements[3] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[3]:SetPoint("TOPLEFT", 180,-60)
        arrayOfElements[3]:SetText(ITEM_LEVEL_ABBR)
        arrayOfElements[3]:Hide()

        arrayOfElements[4] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[4]:SetPoint("TOPLEFT", 230,-60)
        local record,_ = strsplit(":",MYTHIC_PLUS_BEST_WEEKLY)
        arrayOfElements[4]:SetText(record)--рекорд ключ
        arrayOfElements[4]:Hide()

        arrayOfElements[5] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[5]:SetPoint("TOPLEFT", 310,-60)
        local keystone,_ = strsplit(":",CHALLENGE_MODE_KEYSTONE_NAME)
        arrayOfElements[5]:SetText(keystone)
        arrayOfElements[5]:Hide()
        arrayOfElements[1].pmembers = {nil,nil,nil,nil}
        arrayOfElements[1]:SetScript("OnShow",function(self)
            if IsInGroup() then
                C_ChatInfo.SendAddonMessage("WeekKeys","request","PARTY")
            end
            WeekFrame.pIDs = WeekFrame.pIDs or {}
            --UnitLevel("target")
            --UnitName("target")
            --GetRealmName()
            local pmembers = self.pmembers
            pmembers = {nil,nil,nil,nil}
            for i = 1, 4 do
                local target = "party"..i
                local name,realm = UnitName(target)
                if not realm or realm == "" then
                    realm = GetRealmName()
                end
                if name then
                    local _, classFilename, _ = UnitClass(target) -- classname
                    local _, _, _, argbHex = GetClassColor(classFilename) -- ff112233
                    local colored = "|c"..argbHex..name.."|r" -- |cff112233Player|r
                    --db.add(DB,name,realm,colored,ilvl,record,keyid,keylevel,faction,sender)
                    WeekKeys.db.add(WeekFrame.pIDs, name, realm,colored,nil,nil,nil,nil,nil,nil)
                    for k,v in pairs(WeekFrame.pIDs) do
                        if name and v.name == name and v.realm == realm then
                            pmembers[i] = k
                        end
                    end
                end
            end

            --print(#WeekFrame.gIDs , "<=>", self.count)
            if #WeekFrame.pButtons == 0 then
                for i = 1,50 do
                    local pPlayer = CreateFrame('button', 'frameName', arrayOfElements[1], 'InsetFrameTemplate2')
                    pPlayer:SetID(i)
                    local texture = pPlayer:CreateTexture('textureName', 'BACKGROUND')
                    texture:SetPoint('TOPLEFT', 2, -2)
                    texture:SetPoint('bottomright', -2, 2)
                    texture:SetColorTexture(0.2, 0.2, 0.2, 1)
                    pPlayer:SetHighlightTexture(texture)
                    pPlayer:DisableDrawLayer("BORDER")
                    pPlayer:SetNormalFontObject('GameFontNormal')
                    pPlayer:SetSize(WeekFrame:GetWidth()-8, 20)
                    pPlayer:SetPoint("TOPLEFT",4,-(i-1)*20)


                    pPlayer.name = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                    pPlayer.name:SetPoint("LEFT",5,0)

                    pPlayer.realm = ""

                    pPlayer.ilvl = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                    pPlayer.ilvl:SetPoint("LEFT",180,0)

                    pPlayer.record = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                    pPlayer.record:SetPoint("LEFT",240,0)

                    pPlayer.key = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                    pPlayer.key:SetPoint("LEFT",290,0)

                    pPlayer:RegisterForClicks("RightButtonDown","RightButtonUp","LeftButtonUp","LeftButtonDown")
                    pPlayer:SetScript("OnClick",function(self,button,val)
                        if button == "LeftButton" then
                            local sender = self.name:GetText():sub(11,-3) .."-".. self.realm
                            local number = 0
                            for k,v in pairs(WeekFrame.pIDs) do

                               -- /run for k,v in pairs(WeekFrame.pIDs) do print(v.colored," <=> ",tostring(v.keyID), " <=> ", v.keyLevel) end
                                if v.sender and v.sender == sender then
                                    number = number + 1
                                    local btn = WeekFrame.pButtons[number]
                                    btn.name:SetText(v.colored)
                                    btn.ilvl:SetText(v.ilvl or "???")
                                    btn.record:SetText(v.record or "???")
                                    if tonumber(v.keyID) == 370 or tonumber(v.keyID) == 369 then
                                        local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                        local mechagon, zone  = strsplit(" ", name ,2)
                                        if zone then
                                            btn.key:SetText("|cffffffff"..zone .. " ("..v.keyLevel..")")
                                        end
                                    elseif v.keyID and tonumber(v.keyID) then
                                        local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                        if name then
                                            btn.key:SetText("|cffffffff"..name .. " ("..v.keyLevel..")")
                                        end
                                    end
                                    btn:Show()
                                end
                            end
                            if number == 0 then
                                return
                            else
                                while number <= 50 do
                                    WeekFrame.pButtons[number]:Hide()
                                    number = number + 1
                                end
                            end
                            --self.name and self.realm
                            --[[
                            local ID = WeekFrame.gIDs[self:GetID()]
                            local sender = WeekFrame.pIDs[ID].sender
                            local bindex = 1
                            if sender then
                                for k,v in pairs(WeekFrame.pIDs) do
                                    if sender == v.sender then
                                        local btn = WeekFrame.pButtons[bindex]
                                        bindex = bindex + 1
                                        btn.name:SetText(v.name)
                                        btn.ilvl:SetText(v.ilvl or "???")
                                        btn.record:SetText(v.record or "???")
                                        if tonumber(v.keyID) == 370 or tonumber(v.keyID) == 369 then
                                            local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                            local mechagon, zone  = strsplit(" ", name ,2)
                                            if zone then
                                                btn.key:SetText("|cffffffff"..zone .. " ("..v.keyLevel..")")
                                            end
                                        else
                                           -- print("show",)
                                            local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                            if name then
                                                btn.key:SetText("|cffffffff"..name .. " ("..v.keyLevel..")")
                                            end
                                        end
                                        btn:Show()
                                    end
                                end
                                for j = bindex,#WeekFrame.pButtons do
                                    WeekFrame.pButtons[j]:Hide()
                                end
                                
                            end
                            --]]
                        elseif button == "RightButton" then
                            local par = self:GetParent()
                            par:Hide()
                            par:Show()
                            par:Hide()
                            par:Show()
                        end
                    end)
                    tinsert(WeekFrame.pButtons,pPlayer)
                    pPlayer:Hide()
                end
            end
            C_Timer.After(0.5,function()
                local last = 0
                for i = 1, (GetNumGroupMembers()-1) do
                    local target = "party"..i
                    local name,realm = UnitName(target)
                    if not realm or realm == "" then
                        realm = GetRealmName()
                    end
                    for k,v in pairs(WeekFrame.pIDs) do
                        if v.name == name and v.realm == realm then
                            WeekFrame.pButtons[i].name:SetText(v.colored)
                           -- WeekFrame.pButtons[i].charname = v.name
                            WeekFrame.pButtons[i].realm = realm
                            WeekFrame.pButtons[i].ilvl:SetText(v.ilvl or "???")
                            WeekFrame.pButtons[i].record:SetText(v.record or "???")
                            if tonumber(v.keyID) == 370 or tonumber(v.keyID) == 369 then
                                local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                local mechagon, zone  = strsplit(" ", name ,2)
                                WeekFrame.pButtons[i].key:SetText("|cffffffff"..zone .. " ("..(v.keyLevel or "??")..")")
                            elseif v.keyID and v.keyLevel then
                            -- print("show",)
                                local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                WeekFrame.pButtons[i].key:SetText("|cffffffff"..name .. " ("..(v.keyLevel or "??")..")")
                            end
                        end
                    end
                    --[[
                    local player = WeekFrame.pIDs[pmembers[i] ]
                    WeekFrame.pButtons[i].name:SetText(player.colored)
                    WeekFrame.pButtons[i].ilvl:SetText(player.ilvl or "???")
                    WeekFrame.pButtons[i].record:SetText(player.record or "???")
                    if tonumber(player.keyID) == 370 or tonumber(player.keyID) == 369 then
                        local name = C_ChallengeMode.GetMapUIInfo(player.keyID)
                        local mechagon, zone  = strsplit(" ", name ,2)
                        WeekFrame.pButtons[i].key:SetText("|cffffffff"..zone .. " ("..player.keylevel..")")
                    elseif player.keyID then
                       -- print("show",)
                        local name = C_ChallengeMode.GetMapUIInfo(player.keyID)
                        WeekFrame.pButtons[i].key:SetText("|cffffffff"..name .. " ("..player.keylevel..")")
                    end
                    --]]
                    WeekFrame.pButtons[i]:Show()
                    last = i
                end
                for i = last + 1, 50 do
                    WeekFrame.pButtons[i]:Hide()
                end
                
            end)
        end)

        WeekFrame:AddButton(L["partykeys"],arrayOfElements)
    end

-------------------------- guild keys ------------------------------------------
    do

        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame',nil,WeekFrame.ScrollFrame)
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        arrayOfElements[1].count = 0
        WeekFrame.gIDs = {}
        arrayOfElements[2] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[2]:SetPoint("TOPLEFT", 20,-60)
        arrayOfElements[2]:SetText(CHARACTER_NAME_PROMPT)
        arrayOfElements[2]:Hide()

        arrayOfElements[3] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[3]:SetPoint("TOPLEFT", 180,-60)
        arrayOfElements[3]:SetText(ITEM_LEVEL_ABBR)
        arrayOfElements[3]:Hide()

        arrayOfElements[4] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[4]:SetPoint("TOPLEFT", 230,-60)
        local record,_ = strsplit(":",MYTHIC_PLUS_BEST_WEEKLY)
        arrayOfElements[4]:SetText(record)--рекорд ключ
        arrayOfElements[4]:Hide()

        arrayOfElements[5] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[5]:SetPoint("TOPLEFT", 310,-60)
        local keystone,_ = strsplit(":",CHALLENGE_MODE_KEYSTONE_NAME)
        arrayOfElements[5]:SetText(keystone)
        arrayOfElements[5]:Hide()

        arrayOfElements[1]:SetScript("OnShow",function(self)
        --name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, isSoREligible, standingID = GetGuildRosterInfo(index);
        if (IsInGuild()) then
            C_ChatInfo.SendAddonMessage("WeekKeys","request","GUILD")
        end
        local index = 1
            WeekFrame.gIDs = {}
            while GetGuildRosterInfo(index) ~= nil do
                local nameRealm, _, _, level, _, _, _, _, online, _, _, _, _, isMobile, _, _ = GetGuildRosterInfo(index);
                local name,realm = strsplit("-",nameRealm)
                if level < 120 or online == false or isMobile == true then
                    index = index + 1
                else
                    if WeekKeysDB.Guild then
                        for i,data in pairs(WeekKeysDB.Guild) do
                            if (name == data.name) and (data.realm == realm) then
                            -- print(name, "<=>",level, "<=>", isMobile, "<=>",online)
                                tinsert(WeekFrame.gIDs,i)
                            end
                        end
                    end
                    index = index + 1
                end
            end
            local i = 1
            local imax = 50
            if #WeekFrame.gIDs > 50 then
                imax = #WeekFrame.gIDs
            end
            --print(#WeekFrame.gIDs , "<=>", self.count)
            while imax > self.count do
                local localID = WeekFrame.gIDs[i]
                local gPlayer = CreateFrame('button', 'frameName', arrayOfElements[1], 'InsetFrameTemplate2')
                gPlayer:SetID(i)
                local texture = gPlayer:CreateTexture('textureName', 'BACKGROUND')
                texture:SetPoint('TOPLEFT', 2, -2)
                texture:SetPoint('bottomright', -2, 2)
                texture:SetColorTexture(0.2, 0.2, 0.2, 1)
                gPlayer:SetHighlightTexture(texture)
                gPlayer:DisableDrawLayer("BORDER")
                gPlayer:SetNormalFontObject('GameFontNormal')
                gPlayer:SetSize(WeekFrame:GetWidth()-8, 20)
                gPlayer:SetPoint("TOPLEFT",4,-(i-1)*20)


                gPlayer.name = gPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                gPlayer.name:SetPoint("LEFT",5,0)

                gPlayer.ilvl = gPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                gPlayer.ilvl:SetPoint("LEFT",180,0)

                gPlayer.record = gPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                gPlayer.record:SetPoint("LEFT",240,0)

                gPlayer.key = gPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                gPlayer.key:SetPoint("LEFT",290,0)


                if WeekKeysDB.Guild and WeekKeysDB.Guild[localID] then
                    gPlayer.name:SetText(WeekKeysDB.Guild[localID].colored)
                    gPlayer.ilvl:SetText(WeekKeysDB.Guild[localID].ilvl or "???")
                    gPlayer.record:SetText(WeekKeysDB.Guild[localID].record)
                    if WeekKeysDB.Guild[localID].keyID then
                        if tonumber(WeekKeysDB.Guild[localID].keyID) == 370 or tonumber(WeekKeysDB.Guild[localID].keyID) == 369 then
                            local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Guild[localID].keyID)
                            local mechagon, zone = strsplit(" ", name ,2)
                            if zone then
                                gPlayer.key:SetText("|cffffffff"..zone .. " ("..WeekKeysDB.Guild[localID].keyLevel..")")
                            end
                        elseif tonumber(WeekKeysDB.Guild[localID].keyID) then
                            local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Guild[localID].keyID)
                            if name then
                                gPlayer.key:SetText("|cffffffff"..name .. " ("..WeekKeysDB.Guild[localID].keyLevel..")")
                            end
                        end
                    end
                end
                gPlayer:SetScript("OnShow",function(self)
                    if not WeekFrame.gIDs[self:GetID()] then
                        self:Hide()
                        return
                    end
                    local ID = WeekFrame.gIDs[self:GetID()]

                    self.name:SetText(WeekKeysDB.Guild[ID].colored)
                    self.ilvl:SetText(WeekKeysDB.Guild[ID].ilvl or "???")
                    self.record:SetText(WeekKeysDB.Guild[ID].record)
                    if WeekKeysDB.Guild[ID].keyID then
                        if tonumber(WeekKeysDB.Guild[ID].keyID) == 370 or tonumber(WeekKeysDB.Guild[ID].keyID) == 369 then
                            local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Guild[ID].keyID)
                            local mechagon, zone  = strsplit(" ", name ,2)
                            if zone then
                                gPlayer.key:SetText("|cffffffff"..zone .. " ("..WeekKeysDB.Guild[ID].keyLevel..")")
                            end
                        else
                           -- print("show",)
                            local name = C_ChallengeMode.GetMapUIInfo(WeekKeysDB.Guild[ID].keyID)
                            if name then
                                gPlayer.key:SetText("|cffffffff"..name  .. " ("..WeekKeysDB.Guild[ID].keyLevel..")")
                            end
                        end
                    end
                end)
                gPlayer:RegisterForClicks("RightButtonDown","RightButtonUp","LeftButtonUp","LeftButtonDown")
                gPlayer:SetScript("OnClick",function(self,button,val)
                    if button == "LeftButton" then
                        local ID = WeekFrame.gIDs[self:GetID()]
                        local sender = WeekKeysDB.Guild[ID].sender
                        if sender then
                            WeekFrame.gIDs = {}
                            for k,v in pairs(WeekKeysDB.Guild) do
                                if sender == v.sender then
                                    tinsert(WeekFrame.gIDs,k)
                                end
                            end
                            for k,v in pairs(WeekFrame.gButtons) do
                                v:Hide()
                                v:Show()
                            end
                        end
                    elseif button == "RightButton" then
                        local par = self:GetParent()
                        par:Hide()
                        par:Show()
                        par:Hide()
                        par:Show()
                    end
                end)
                tinsert(WeekFrame.gButtons,gPlayer)
                i = i + 1
                self.count = self.count + 1
                gPlayer:Hide()
            end

            for i = 1, #WeekFrame.gButtons do
                if WeekFrame.gIDs[i] then
                    WeekFrame.gButtons[i]:Show()
                    WeekFrame.gButtons[i]:Hide()
                    WeekFrame.gButtons[i]:Show()
                else
                    WeekFrame.gButtons[i]:Hide()
                end
            end
            C_Timer.After(0.5,function()
                WeekFrame.gIDs = {}
                local index = 1
                while GetGuildRosterInfo(index) ~= nil do
                    local nameRealm, _, _, level, _, _, _, _, online, _, _, _, _, isMobile, _, _ = GetGuildRosterInfo(index);
                    local name,realm = strsplit("-",nameRealm)
                    if level < 120 or online == false or isMobile == true then
                        index = index + 1
                    else
                        if WeekKeysDB.Guild then
                            for i,data in pairs(WeekKeysDB.Guild) do
                                if (name == data.name) and (data.realm == realm) then
                                -- print(name, "<=>",level, "<=>", isMobile, "<=>",online)
                                    tinsert(WeekFrame.gIDs,i)
                                end
                            end
                        end
                        index = index + 1
                    end
                end
                for i = 1, #WeekFrame.gButtons do
                    if WeekFrame.gIDs[i] then
                        WeekFrame.gButtons[i]:Show()
                        WeekFrame.gButtons[i]:Hide()
                        WeekFrame.gButtons[i]:Show()
                    else
                        WeekFrame.gButtons[i]:Hide()
                    end
                end
            end)
        end)

        WeekFrame:AddButton(L["guildkeys"],arrayOfElements)
    end
------------------ friends -------------------
do

    local arrayOfElements = {}
    arrayOfElements[1] = CreateFrame('Frame',nil,WeekFrame.ScrollFrame)
    arrayOfElements[1]:SetFrameStrata("BACKGROUND")
    arrayOfElements[1]:SetSize(10,10)
    arrayOfElements[1].count = 0

    arrayOfElements[2] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    arrayOfElements[2]:SetPoint("TOPLEFT", 20,-60)
    arrayOfElements[2]:SetText(CHARACTER_NAME_PROMPT)
    arrayOfElements[2]:Hide()

    arrayOfElements[3] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    arrayOfElements[3]:SetPoint("TOPLEFT", 180,-60)
    arrayOfElements[3]:SetText(ITEM_LEVEL_ABBR)
    arrayOfElements[3]:Hide()

    arrayOfElements[4] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    arrayOfElements[4]:SetPoint("TOPLEFT", 230,-60)
    local record,_ = strsplit(":",MYTHIC_PLUS_BEST_WEEKLY)
    arrayOfElements[4]:SetText(record)--рекорд ключ
    arrayOfElements[4]:Hide()

    arrayOfElements[5] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
    arrayOfElements[5]:SetPoint("TOPLEFT", 310,-60)
    local keystone,_ = strsplit(":",CHALLENGE_MODE_KEYSTONE_NAME)
    arrayOfElements[5]:SetText(keystone)
    arrayOfElements[5]:Hide()
    arrayOfElements[1].pmembers = {nil,nil,nil,nil}
    arrayOfElements[1]:SetScript("OnShow",function(self)
        local i = 1
        while C_BattleNet.GetFriendAccountInfo(i) do
            local friend = C_BattleNet.GetFriendAccountInfo(i)
            local id = friend.gameAccountInfo.gameAccountID
            if friend.gameAccountInfo.clientProgram == "WoW" then
                BNSendGameData(id, "WeekKeys", "request")
            end
            i = i + 1
        end

        if #WeekFrame.fButtons == 0 then
            for i = 1,100 do
                local pPlayer = CreateFrame('button', 'frameName', arrayOfElements[1], 'InsetFrameTemplate2')
                pPlayer:SetID(i)
                local texture = pPlayer:CreateTexture('textureName', 'BACKGROUND')
                texture:SetPoint('TOPLEFT', 2, -2)
                texture:SetPoint('bottomright', -2, 2)
                texture:SetColorTexture(0.2, 0.2, 0.2, 1)
                pPlayer:SetHighlightTexture(texture)
                pPlayer:DisableDrawLayer("BORDER")
                pPlayer:SetNormalFontObject('GameFontNormal')
                pPlayer:SetSize(WeekFrame:GetWidth()-8, 20)
                pPlayer:SetPoint("TOPLEFT",4,-(i-1)*20)


                pPlayer.name = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                pPlayer.name:SetPoint("LEFT",5,0)

                pPlayer.realm = ""

                pPlayer.ilvl = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                pPlayer.ilvl:SetPoint("LEFT",180,0)

                pPlayer.record = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                pPlayer.record:SetPoint("LEFT",240,0)

                pPlayer.key = pPlayer:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                pPlayer.key:SetPoint("LEFT",290,0)

                pPlayer:RegisterForClicks("RightButtonDown","RightButtonUp","LeftButtonUp","LeftButtonDown")
                pPlayer:SetScript("OnClick",function(self,button,val)
                    if button == "LeftButton" then
                        local battletag = string.gsub(self.name:GetText(),"|cffffffff","")
                        local number = 0
                        if not WeekKeysDB.friends[battletag] then
                            return
                        end
                        for _,v in pairs(WeekKeysDB.friends[battletag]) do

                           -- /run for k,v in pairs(WeekFrame.pIDs) do print(v.colored," <=> ",tostring(v.keyID), " <=> ", v.keyLevel) end
                            
                            number = number + 1
                            local btn = WeekFrame.fButtons[number]
                            btn.name:SetText(v.colored)
                            btn.ilvl:SetText(v.ilvl or "???")
                            btn.record:SetText(v.record or "???")
                            if tonumber(v.keyID) == 370 or tonumber(v.keyID) == 369 then
                                local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                local mechagon, zone  = strsplit(" ", name ,2)
                                if zone then
                                    btn.key:SetText("|cffffffff"..zone .. " ("..v.keyLevel..")")
                                end
                            elseif v.keyID and tonumber(v.keyID) then
                                local name = C_ChallengeMode.GetMapUIInfo(v.keyID)
                                if name then
                                    btn.key:SetText("|cffffffff"..name .. " ("..v.keyLevel..")")
                                end
                            end
                            btn:Show()
                            
                        end
                        if number == 0 then
                            return
                        else
                            number = number + 1
                            while number <= 100 do
                                WeekFrame.fButtons[number]:Hide()
                                number = number + 1
                            end
                        end
                        
                    elseif button == "RightButton" then
                        local par = self:GetParent()
                        par:Hide()
                        par:Show()
                    end
                end)
                tinsert(WeekFrame.fButtons,pPlayer)
                pPlayer:Hide()
            end
        end
        C_Timer.After(0.5,function()
            local last = 0

            for tag,_ in pairs(WeekKeysDB.friends) do
                last = last + 1
                WeekFrame.fButtons[last].name:SetText("|cffffffff"..tag)
                WeekFrame.fButtons[last].ilvl:SetText("")
                WeekFrame.fButtons[last].record:SetText("")
                WeekFrame.fButtons[last].key:SetText("")
                WeekFrame.fButtons[last]:Show()
            end
            for i = last + 1, 100 do
                WeekFrame.fButtons[i]:Hide()
            end
        end)
    end)

    WeekFrame:AddButton(L["friends"],arrayOfElements)
end

-------------------------------- level keys --------------------------


    do
        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame')
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        local Rio_de_Janeiro = {20,30,40,50,60,70,80,90,100,110,121,133,146,161,177,195,214,236,259,285,314,345,380,418,459,505,556,612,673}
        local i = 0
        for level = 2,30 do
            local color = "|cffffffff" --hex for white color
            local chest, key = C_MythicPlus.GetRewardLevelForDifficultyLevel(level) -- api for loot
            local dmghp = C_ChallengeMode.GetPowerLevelDamageHealthMod(level)
            local levelData = CreateFrame('button',nil , arrayOfElements[1], 'InsetFrameTemplate2')
            levelData:SetID(level)
            local armor_icon = "|Tinterface/icons/garrison_purplearmor.blp:15:15|t"
            local echo = "|Tinterface/icons/inv_inscription_80_vantusrune_nyalotha.blp:15:15|t"
            local texture = levelData:CreateTexture('textureName', 'BACKGROUND')
            texture:SetAllPoints(true)
            texture:SetColorTexture(0.2, 0.2, 0.2, 1)
            -- white / grey buttons
            if i % 2 == 0 then
                local texture2 = levelData:CreateTexture('textureName2', 'ARTWORK')
                texture2:SetAllPoints(true)
                texture2:SetColorTexture(0.2, 0.2, 0.2, 1)
                levelData:SetNormalTexture(texture2)
            end
            levelData:SetHighlightTexture(texture)
            levelData:DisableDrawLayer("BORDER")
            levelData:SetNormalFontObject('GameFontNormal')
            levelData:SetSize(WeekFrame:GetWidth()-8, 20)
            levelData:SetPoint("TOPLEFT",4,-i*20)


            levelData.name = levelData:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            levelData.name:SetPoint("LEFT",20,0)
            levelData.name:SetText(color..level)

            levelData.ilvl = levelData:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            levelData.ilvl:SetPoint("LEFT",85,0)
            levelData.ilvl:SetText(color..chest..armor_icon)
            levelData.chest = chest

            levelData.chestEcho = levelData:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            levelData.chestEcho:SetPoint("LEFT",130,0)
            levelData.chestEcho:SetText(color..string.format("%4d",(level*100))..echo)
            --..echo..(i*15)
            levelData.record = levelData:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            levelData.record:SetPoint("LEFT",215,0)
            levelData.record:SetText(color..key..armor_icon)
            levelData.key = key

            levelData.recordEcho = levelData:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            levelData.recordEcho:SetPoint("LEFT",255,0)
            levelData.recordEcho:SetText(color..string.format("%4d",(level*15))..echo)

            levelData.name = levelData:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            levelData.name:SetPoint("LEFT",335,0)
            levelData.name:SetText(color..Rio_de_Janeiro[i+1])

            levelData.dmghp = levelData:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            levelData.dmghp:SetPoint("LEFT",410,0)
            levelData.dmghp:SetText(color..dmghp.." %")
            -- try to fix the error with 0 ilvl from keys
           --[[if levelData.chest == 0 or levelData.key == 0 then
                levelData:SetScript("OnUpdate",function(self)
                    local Level = self:GetID()
                    local Chest, Key = C_MythicPlus.GetRewardLevelForDifficultyLevel(Level)
                    local dmghp = C_ChallengeMode.GetPowerLevelDamageHealthMod(level)
                    levelData.chest = Chest
                    levelData.key = Key
                    levelData.ilvl:SetText(color..chest)
                    levelData.record:SetText(color..key)
                    levelData.dmghp:SetText(color..dmghp.." %")
                    if levelData.chest ~= 0 and levelData.key ~= 0 then
                        self:SetScript("OnUpdate",nil)
                    end
                end)
            end--]]
            i = i + 1
        end
        arrayOfElements[2] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[2]:SetPoint("TOPLEFT", 20,-60)
        arrayOfElements[2]:SetText(LEVEL_ABBR)
        arrayOfElements[2]:Hide()

        arrayOfElements[3] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[3]:SetPoint("TOPLEFT", 85,-60)
        arrayOfElements[3]:SetText(MYTHIC_PLUS_WEEKLY_BEST)
        arrayOfElements[3]:Hide()

        arrayOfElements[4] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[4]:SetPoint("TOPLEFT", 220,-60)
        arrayOfElements[4]:SetText(L["keypush"])--рекорд ключ
        arrayOfElements[4]:Hide()

        arrayOfElements[5] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[5]:SetPoint("TOPLEFT", 345,-60)
        arrayOfElements[5]:SetText(L["rio"])
        arrayOfElements[5]:Hide()

        arrayOfElements[6] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[6]:SetPoint("TOPLEFT", 395,-60)
        arrayOfElements[6]:SetText(L["modifier"])
        arrayOfElements[6]:Hide()

        WeekFrame:AddButton(L["mmtable"],arrayOfElements)
    end

    -- loot finder
    do
        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame')
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        arrayOfElements[1]:SetScript("OnShow",function()
            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -300);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
        end)
        arrayOfElements[1]:SetScript("OnHide",function()
            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -80);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
        end)
        arrayOfElements[1]:Hide()
        for i = 1, 12 do
            arrayOfElements[i+1] = CreateFrame("button",nil,WeekFrame)
            arrayOfElements[i+1]:SetPoint("TOPLEFT",0+i*35,-35)
            arrayOfElements[i+1]:SetSize(35,35)
            arrayOfElements[i+1]:SetID(i)
            arrayOfElements[i+1].icon = arrayOfElements[i+1]:CreateTexture(nil,"BACKGROUND"); -- create texture as child of myframe
            arrayOfElements[i+1].icon:SetAllPoints(arrayOfElements[i+1]); -- copy dimensions of myframe to icon
            local _, class, _ = GetClassInfo(i)
           -- local _,class = UnitClass("player"); -- get non-localized class name
            arrayOfElements[i+1].icon:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES"); -- this is the image containing all class icons
            local coords = CLASS_ICON_TCOORDS[class]; -- get the coordinates of the class icon we want
            arrayOfElements[i+1].icon:SetTexCoord(unpack(coords)); -- cut out the region with our class icon according to coords
            arrayOfElements[i+1].icon2 = arrayOfElements[i+1]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
            arrayOfElements[i+1].icon2:SetAllPoints(arrayOfElements[i+1]);
            arrayOfElements[i+1]:SetScript("onclick",function(self)
                self.icon2:SetColorTexture(1,1,1,0.3)
                if LootFinder.class ~= 0 and LootFinder.class ~= self:GetID() then
                    WeekFrame.ClassBtn[LootFinder.class].icon2:SetColorTexture(1,1,1,0)
                end
                for k,v in pairs(WeekFrame.SpecBtn) do
                    v.icon2:SetColorTexture(1,1,1,0)
                end
                LootFinder.class = self:GetID()
                LootFinder.spec = 0
                -- hide/show specialization button
                for j = 1, #WeekFrame.SpecBtn do
                    if LootFinder.class_spec[LootFinder.class][j] == nil then
                        WeekFrame.SpecBtn[j]:Hide()
                    else
                        local specID = LootFinder.class_spec[LootFinder.class][j]
                        local _, _, _, icon, _, _ = GetSpecializationInfoByID(specID)
                        WeekFrame.SpecBtn[j].icon:SetTexture(icon)
                        WeekFrame.SpecBtn[j]:Show()
                    end
                end
            end)
            arrayOfElements[i+1]:Hide()
            tinsert(WeekFrame.ClassBtn,arrayOfElements[i+1])
        end
        for i = 1, 4 do
            arrayOfElements[i+13] = CreateFrame("button",nil,WeekFrame)
            arrayOfElements[i+13]:SetPoint("TOPLEFT",150+i*35,-85)
            arrayOfElements[i+13]:SetSize(35,35)
            arrayOfElements[i+13]:SetID(i)
            arrayOfElements[i+13].icon = arrayOfElements[i+13]:CreateTexture(nil,"BACKGROUND");
            arrayOfElements[i+13].icon:SetAllPoints(arrayOfElements[i+13])
            arrayOfElements[i+13].icon2 = arrayOfElements[i+13]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
            arrayOfElements[i+13].icon2:SetAllPoints(arrayOfElements[i+13]);
            tinsert(WeekFrame.SpecBtn,arrayOfElements[i+13])
            arrayOfElements[i+13]:SetScript("OnShow",function(self)
                if LootFinder.class == 0 then
                    self:Hide()
                    return
                end
            end)
            arrayOfElements[i+13]:SetScript("OnClick",function(self)
                self.icon2:SetColorTexture(1,1,1,0.3)
                for k,v in pairs(WeekFrame.SpecBtn) do
                    if k ~= self:GetID() then
                        v.icon2:SetColorTexture(1,1,1,0)
                    end
                end
                LootFinder.spec = LootFinder.class_spec[LootFinder.class][self:GetID()]
            end)
        end
        --18
        local icons = {133070,133292,135061,133771,132751,132616,132939,132511,134584,132535,135317,134959,801523,133441}
        local slots = {1,2,3,16,5,9,10,6,7,8,21,22,11,12}
        for i = 1, 14 do
            arrayOfElements[i+17] = CreateFrame("button",nil,WeekFrame)
            arrayOfElements[i+17]:SetPoint("TOPLEFT",-30+i*35,-145)
            arrayOfElements[i+17]:SetSize(35,35)
            arrayOfElements[i+17]:SetID(slots[i])
            arrayOfElements[i+17].icon = arrayOfElements[i+17]:CreateTexture(nil,"BACKGROUND");
            arrayOfElements[i+17].icon:SetAllPoints(arrayOfElements[i+17])
            arrayOfElements[i+17].icon:SetTexture(icons[i])
            arrayOfElements[i+17].icon2 = arrayOfElements[i+17]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
            arrayOfElements[i+17].icon2:SetAllPoints(arrayOfElements[i+17]);
            arrayOfElements[i+17]:Hide()
            arrayOfElements[i+17]:SetScript("OnClick",function(self)
                LootFinder.slot = self:GetID()
                self.icon2:SetColorTexture(1,1,1,0.3)
                for k,v in pairs(WeekFrame.SlotBtn) do
                    if v:GetID() ~= self:GetID() then
                        v.icon2:SetColorTexture(1,1,1,0)
                    end
                end
            end)
            tinsert(WeekFrame.SlotBtn,arrayOfElements[i+17])
        end
        --236372
        arrayOfElements[35] = CreateFrame("button",nil,WeekFrame)
        arrayOfElements[35]:SetPoint("TOPLEFT",-30+14*35,-110)
        arrayOfElements[35]:SetSize(35,35)
        arrayOfElements[35].icon = arrayOfElements[35]:CreateTexture(nil,"CENTER");
        arrayOfElements[35].icon:SetAllPoints(arrayOfElements[35])
        arrayOfElements[35].icon:SetTexture(236372)
        arrayOfElements[35]:Hide()
        arrayOfElements[35]:SetScript("OnClick",function(self)
            LootFinder.slot = 0
            for k,v in pairs(WeekFrame.SlotBtn) do
                v.icon2:SetColorTexture(1,1,1,0)
            end
        end)
        arrayOfElements[35]:SetScript("OnEnter",function(self)
            GameTooltip:Hide();
            GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
            GameTooltip:AddLine(L["removeslot"],1,1,1)
            GameTooltip:Show()
        end)
        arrayOfElements[35]:SetScript("OnLeave",function(self)
            GameTooltip:Hide();
        end)
        --32
        arrayOfElements[32] = CreateFrame("Frame", "Stating1", WeekFrame, "UIDropDownMenuTemplate")
        arrayOfElements[32]:SetPoint("TOPLEFT",10,-190)
        UIDropDownMenu_SetWidth(arrayOfElements[32], 100)
        UIDropDownMenu_Initialize(arrayOfElements[32], WeekFrame.WPDropDownDemo_Menu1)
        UIDropDownMenu_SetText(arrayOfElements[32],OPTIONAL)
        arrayOfElements[32]:Hide()

        arrayOfElements[33] = CreateFrame("Frame", "Stating2", WeekFrame, "UIDropDownMenuTemplate")
        arrayOfElements[33]:SetPoint("TOPLEFT",10,-220)
        UIDropDownMenu_SetWidth(arrayOfElements[33], 100)
        UIDropDownMenu_Initialize(arrayOfElements[33], WeekFrame.WPDropDownDemo_Menu2)
        UIDropDownMenu_SetText(arrayOfElements[33],OPTIONAL)
        arrayOfElements[33]:Hide()

        arrayOfElements[34] = CreateFrame("Button",nil,WeekFrame,"UIPanelButtonTemplate")
        arrayOfElements[34]:SetPoint("TOPLEFT",30,-260)
        arrayOfElements[34]:SetSize(120,30)
        arrayOfElements[34]:SetText(SEARCH)
        arrayOfElements[34]:SetScript("OnClick",function()
            LootFinder:Find()
            for i = 1, #WeekFrame.LootBtn do
                if LootFinder.LootList[i] then
                    WeekFrame.LootBtn[i]:Hide()
                    WeekFrame.LootBtn[i]:Show()
                else
                    WeekFrame.LootBtn[i]:Hide()
                end
            end

            for i = #WeekFrame.LootBtn + 1,#LootFinder.LootList do
                local lInfo = CreateFrame('button', 'frameName', arrayOfElements[1], 'InsetFrameTemplate2')
                lInfo:SetID(i)
                local texture = lInfo:CreateTexture('textureName', 'BACKGROUND')
                texture:SetPoint('TOPLEFT', 2, -2)
                texture:SetPoint('bottomright', -2, 2)
                texture:SetColorTexture(0.2, 0.2, 0.2, 1)
                lInfo:SetHighlightTexture(texture)
                lInfo:DisableDrawLayer("BORDER")
                lInfo:SetNormalFontObject('GameFontNormal')
                lInfo:SetSize(WeekFrame:GetWidth()-8, 20)
                lInfo:SetPoint("TOPLEFT",4,-(i-1)*20)

                lInfo.instance = lInfo:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                lInfo.instance:SetPoint("LEFT",5,0)
                lInfo.instance:SetText(LootFinder.LootList[i][1])

                local itemname = GetItemInfo(LootFinder.LootList[i][2])
                lInfo.item = lInfo:CreateFontString(nil , "ARTWORK", "GameFontNormal")
                lInfo.item:SetPoint("LEFT",160,0)
                lInfo.item:SetText("|cffffffff"..itemname)

                lInfo:SetScript("OnShow",function(self)
                    local id = self:GetID()
                    if not LootFinder.LootList[id] then
                        self:Hide()
                    end
                    self.instance:SetText(LootFinder.LootList[id][1])

                    local itemName = GetItemInfo(LootFinder.LootList[id][2])
                    self.item:SetText("|cffffffff"..itemName)
                end)

                lInfo:SetScript("OnEnter",function(self)
                    GameTooltip:Hide();
                    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                    GameTooltip:SetHyperlink(LootFinder.LootList[self:GetID()][2])
                    GameTooltip:Show()
                end)
                lInfo:SetScript("OnLeave",function(self)
                    GameTooltip:Hide();
                end)
                tinsert(WeekFrame.LootBtn,lInfo)
            end
        end)
        arrayOfElements[34]:Hide()

        arrayOfElements[36] = CreateFrame("EditBox",nil,WeekFrame,"InputBoxTemplate")
        arrayOfElements[36]:SetAutoFocus(false)
        arrayOfElements[36]:SetPoint("TOPLEFT",-30+12*35,-220)
        arrayOfElements[36]:SetSize(50,20)
        arrayOfElements[36]:SetNumber(15)
        arrayOfElements[36]:ClearFocus()
        arrayOfElements[36]:SetMaxLetters(2)
        arrayOfElements[36]:SetNumeric(true)

        arrayOfElements[36]:SetScript("OnEditFocusLost",function(self)
            LootFinder.level = max(self:GetNumber(), 2)
            C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
            self:ClearFocus()
        end)

        arrayOfElements[36]:SetScript("OnShow",function()
            C_EncounterJournal.SetPreviewMythicPlusLevel(LootFinder.level)
        end)
        arrayOfElements[36]:SetScript("OnHide",function()
            C_EncounterJournal.SetPreviewMythicPlusLevel(0)
        end)

        arrayOfElements[36]:Hide()

        arrayOfElements[37] = WeekFrame:CreateFontString(nil , "BORDER", "GameFontNormal")
        arrayOfElements[37]:SetPoint("TOPLEFT",-30+12*35,-200)
        arrayOfElements[37]:SetText(GUILD_RECRUITMENT_LEVEL)
        arrayOfElements[37]:Hide()

        local iIndex = 1
        while EJ_GetInstanceByIndex(iIndex, false) ~= nil do

            local _, name, _, bgim, buttonImage1, loreImage, buttonImage2 = EJ_GetInstanceByIndex(iIndex, false)
           -- print(bgim,buttonImage1, loreImage, buttonImage2)
            arrayOfElements[iIndex+37] = CreateFrame("button",nil,WeekFrame)
            arrayOfElements[iIndex+37]:SetPoint("TOPLEFT",160+((iIndex-1)%6)*35,-210-math.floor((iIndex-1)/6)*35)
            arrayOfElements[iIndex+37]:SetSize(35,35)
            arrayOfElements[iIndex+37]:SetID(iIndex)
            arrayOfElements[iIndex+37].icon = arrayOfElements[iIndex+37]:CreateTexture(nil,"BACKGROUND");
            arrayOfElements[iIndex+37].icon:SetAllPoints(arrayOfElements[iIndex+37])
            arrayOfElements[iIndex+37].icon:SetTexture(buttonImage2)
            arrayOfElements[iIndex+37].icon2 = arrayOfElements[iIndex+37]:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
            arrayOfElements[iIndex+37].icon2:SetAllPoints(arrayOfElements[iIndex+37]);
            local btn = arrayOfElements[iIndex+37]
            btn.find = true
            function btn:enable(bool)
                if bool then
                    LootFinder.instances[self:GetID()] = true
                    self.icon2:SetColorTexture(0,0,0,0)
                else
                    LootFinder.instances[self:GetID()] = false
                    self.icon2:SetColorTexture(0,0,0,0.6)
                end
                self.find = bool
            end
            arrayOfElements[iIndex+37]:SetScript("OnClick",function(self)
                self:enable(not self.find)
            end)
            arrayOfElements[iIndex+37]:Hide()
            iIndex = iIndex + 1
        end

        WeekFrame:AddButton(L["lootfinder"],arrayOfElements)
    end
    --m.o.t.h.e.r
    do
        local echo = " |Tinterface/icons/inv_inscription_80_vantusrune_nyalotha.blp:15:15|t"
        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame')
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        arrayOfElements[1]:SetScript("OnShow",function ()

            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -45);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);

            local nextRotation = 0
            local rotation = -1
            local i = 1
            local color = "|cff00ff00  "
            if GetCurrentRegion() == 3 then
                -- 1589958000 -- begin EU
                nextRotation = 302400 -  (GetServerTime() - 1589958000) % 302400
                rotation = math.floor(((GetServerTime() - 1589958000) % 2419200) /302400)
            elseif GetCurrentRegion() == 2 then
				-- 1590015600 Asia?
				nextRotation = 302400 - (GetServerTime() - 1590015600) % 302400
                rotation = math.floor(((GetServerTime() - 1590015600) % 2419200) /302400)
            else
                -- 1589900400 -- begin US
                nextRotation = 302400 - (GetServerTime() - 1589900400) % 302400
                rotation = math.floor(((GetServerTime() - 1589900400) % 2419200) /302400)
            end

            for j=rotation,(rotation+10) do
                for _,data in pairs(corruptlist[j%8+1]) do
                    WeekFrame.Mother[i].name:SetFormattedText(WeekKeys.iconStr[data[1]]..color..(WeekFrame.CorruptNames[data[1]]).." ("..WeekKeys.CorruptionTier[data[1]]..")")
                    WeekFrame.Mother[i].cost:SetFormattedText(color .. string.format("%5d",data[2])..echo)
                    if j == rotation then
                        WeekFrame.Mother[i].time:SetFormattedText(color.."------")
                    else
                        -- GARRISON_DURATION_DAYS_HOURS
                        local days = math.floor(nextRotation/86400)
                        local hours = math.floor(nextRotation%86400/3600)
                        WeekFrame.Mother[i].time:SetFormattedText(color..DAY_ONELETTER_ABBR.." "..HOUR_ONELETTER_ABBR,days,hours)
                    end
                    WeekFrame.Mother[i]:SetID(data[1])
                    WeekFrame.Mother[i]:Show()
                    i = i + 1
                end
                if color == "|cffffffff  " then
                    color = "  "
                else
                    color = "|cffffffff  "
                end
                if j == rotation then
                    rotation = -1
                else
                    nextRotation = nextRotation + 302400
                end
            end
        end)
        arrayOfElements[1]:SetScript("OnHide",function()
            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -80);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
        end)
        arrayOfElements[1]:Hide()
        arrayOfElements[2] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[2]:SetPoint("TOPLEFT",35,-32)
        arrayOfElements[2]:SetText(CALENDAR_EVENT_NAME)
        arrayOfElements[2]:Hide()

        arrayOfElements[3] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[3]:SetPoint("TOPLEFT",320,-32)
        local time = string.gsub(GARRISON_MISSION_TIME_TOTAL,"%%s","")
        arrayOfElements[3]:SetText(time)
        arrayOfElements[3]:Hide()

        arrayOfElements[4] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[4]:SetPoint("TOPLEFT",415,-32)
        arrayOfElements[4]:SetText(AUCTION_HOUSE_BROWSE_HEADER_PRICE)
        arrayOfElements[4]:Hide()

        for i = 1, 100 do
            local corrupt = CreateFrame('button',nil , arrayOfElements[1], 'InsetFrameTemplate2')
            local texture = corrupt:CreateTexture('textureName', 'BACKGROUND')
            texture:SetAllPoints(true)
            texture:SetColorTexture(0.2, 0.2, 0.2, 1)
            corrupt:SetHighlightTexture(texture)
            corrupt:DisableDrawLayer("BORDER")
            corrupt:SetNormalFontObject('GameFontNormal')
            corrupt:SetSize(WeekFrame:GetWidth()-30, 20)
            corrupt:SetPoint("TOPLEFT",4,-(i-1)*20)


            corrupt.name = corrupt:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            corrupt.name:SetPoint("LEFT",5,0)

            corrupt.cost = corrupt:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            corrupt.cost:SetPoint("LEFT",390,0)

            corrupt.time = corrupt:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            corrupt.time:SetPoint("LEFT",295,0)

            corrupt:Hide()
            corrupt:SetScript("OnEnter",function(self)
                GameTooltip:Hide();
                GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                GameTooltip:SetHyperlink(WeekFrame.CorruptLinks[self:GetID()])
                GameTooltip:Show()
            end)
            corrupt:SetScript("OnLeave",function(self)
                GameTooltip:Hide();
            end)


            tinsert(WeekFrame.Mother,corrupt)
        end


        WeekFrame:AddButton(L["mother"],arrayOfElements)
    end
    -- corrupt
    do


        local echo = " |Tinterface/icons/inv_inscription_80_vantusrune_nyalotha.blp:15:15|t"
        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame')
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        arrayOfElements[1]:SetScript("OnShow",function()
            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -45);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
            local nextRotation = 0
            local currentRotation = -1
            local color = "|cffffffff"
            if GetCurrentRegion() == 3 then
                -- 1589958000 -- begin EU
                nextRotation = 302400 - (GetServerTime() - 1589958000) % 302400
                currentRotation = math.floor(((GetServerTime() - 1589958000) % 2419200) /302400)
            elseif GetCurrentRegion() == 2 then
				-- 1590015600 Asia?
				nextRotation = 302400 - (GetServerTime() - 1590015600) % 302400
                currentRotation = math.floor(((GetServerTime() - 1590015600) % 2419200) /302400)
            else
                -- 1589900400 -- begin US
                nextRotation = 302400 - (GetServerTime() - 1589900400) % 302400
                currentRotation = math.floor(((GetServerTime() - 1589900400) % 2419200) /302400)
            end
            for i,id in pairs(list) do
                for rotation, corrupts in pairs(corruptlist) do
                    for _, corrputinfo in pairs(corrupts) do
                        if id == corrputinfo[1] then
                           -- local iconstr = WeekKeys.Icon(id)
                            --local corruptionTier = WeekKeys.CorruptionTier(id)
                            if i % 3 == 1 then
                                if color == "|cffffffff  " then
                                    color = "  "
                                else
                                    color = "|cffffffff  "
                                end
                            end
                            WeekFrame.Corrupt[i]:SetID(id)
                            WeekFrame.Corrupt[i].name:SetText(WeekKeys.iconStr[id]..color..WeekFrame.CorruptNames[id] .." ("..WeekKeys.CorruptionTier[id]..")")
                            WeekFrame.Corrupt[i].cost:SetText(color..string.format("%5d",corrputinfo[2])..echo)
                            if rotation == (currentRotation + 1) then -- +1 because table starts from 1
                                WeekFrame.Corrupt[i].time:SetText(color.."------")
                            elseif rotation - (currentRotation + 1) > 0 then
                             --   print(rotation,currentRotation,fullitemname)
                                local days = math.floor((nextRotation + (rotation - currentRotation - 2)*302400) / 86400)
                                local hours = math.floor((nextRotation + (rotation - currentRotation - 2)*302400) % 86400 / 3600)
                                --HOUR_ONELETTER_ABBR
                                -- DAY_ONELETTER_ABBR
                                WeekFrame.Corrupt[i].time:SetFormattedText(color..DAY_ONELETTER_ABBR.." "..HOUR_ONELETTER_ABBR,days,hours)
                            else
                                local days = math.floor((nextRotation + (rotation - currentRotation + 6)*302400) / 86400)
                                local hours = math.floor((nextRotation + (rotation - currentRotation - 2)*302400) % 86400 / 3600)
                                WeekFrame.Corrupt[i].time:SetFormattedText(color..DAY_ONELETTER_ABBR.." "..HOUR_ONELETTER_ABBR,days,hours)
                            end
                            WeekFrame.Corrupt[i]:Show()
                        end
                    end
                end
            end
           -- collectgarbage("collect") -- reduce memory usage, when spam corruption button
        end)
        arrayOfElements[1]:SetScript("OnHide",function()
            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -80);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
        end)
        arrayOfElements[1]:Show()
        arrayOfElements[1]:Hide()
        arrayOfElements[2] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[2]:SetPoint("TOPLEFT",35,-32)
        arrayOfElements[2]:SetText(CALENDAR_EVENT_NAME)
        arrayOfElements[2]:Hide()

        arrayOfElements[3] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[3]:SetPoint("TOPLEFT",320,-32)
        local time = string.gsub(GARRISON_MISSION_TIME_TOTAL,"%%s","")
        arrayOfElements[3]:SetText(time)
        arrayOfElements[3]:Hide()

        arrayOfElements[4] = WeekFrame:CreateFontString(nil , "ARTWORK", "GameFontNormal")
        arrayOfElements[4]:SetPoint("TOPLEFT",415,-32)
        arrayOfElements[4]:SetText(AUCTION_HOUSE_BROWSE_HEADER_PRICE)
        arrayOfElements[4]:Hide()

        for i = 1, 52 do
            local corrupt = CreateFrame('button',nil , arrayOfElements[1], 'InsetFrameTemplate2')
            local texture = corrupt:CreateTexture('textureName', 'BACKGROUND')
            texture:SetAllPoints(true)
            texture:SetColorTexture(0.2, 0.2, 0.2, 1)
            corrupt:SetHighlightTexture(texture)
            corrupt:DisableDrawLayer("BORDER")
            corrupt:SetNormalFontObject('GameFontNormal')
            corrupt:SetSize(WeekFrame:GetWidth()-30, 20)
            corrupt:SetPoint("TOPLEFT",4,-(i-1)*20)


            corrupt.name = corrupt:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            corrupt.name:SetPoint("LEFT",5,0)

            corrupt.cost = corrupt:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            corrupt.cost:SetPoint("LEFT",390,0)

            corrupt.time = corrupt:CreateFontString(nil , "ARTWORK", "GameFontNormal")
            corrupt.time:SetPoint("LEFT",295,0)

            corrupt:Hide()
            corrupt:SetScript("OnEnter",function(self)
                GameTooltip:Hide();
                GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                GameTooltip:SetHyperlink(WeekFrame.CorruptLinks[self:GetID()])
                GameTooltip:Show()
            end)

            corrupt:SetScript("OnLeave",function(self)
                GameTooltip:Hide();
            end)


            tinsert(WeekFrame.Corrupt,corrupt)
        end
        WeekFrame:AddButton(L["corruptlist"],arrayOfElements)
    end
    --settings
    do
        local arrayOfElements = {}
        arrayOfElements[1] = CreateFrame('Frame')
        arrayOfElements[1]:SetFrameStrata("BACKGROUND")
        arrayOfElements[1]:SetSize(10,10)
        arrayOfElements[1]:SetScript("OnShow",function()
            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -25);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
        end)
        arrayOfElements[1]:SetScript("OnHide",function()
            WeekFrame.ScrollFrame:ClearAllPoints()
            WeekFrame.ScrollFrame:SetPoint("TOPLEFT", WeekFrame, "TOPLEFT", 4, -80);
            WeekFrame.ScrollFrame:SetPoint("BOTTOMRIGHT", WeekFrame, "BOTTOMRIGHT", -5, 5);
        end)
        arrayOfElements[1]:Hide()

        local myCheckButton = CreateFrame("CheckButton", "WeekKeys_CheckButton1", arrayOfElements[1], "ChatConfigCheckButtonTemplate");
        myCheckButton:SetPoint("TOPLEFT", 10, -15);
        WeekKeys_CheckButton1Text:SetText(L["pkeys_react"]);
        myCheckButton.tooltip = L["pkeys_react_tooltip"];
        if WeekKeysDB.Settings["pkeyslink"] == true then
            myCheckButton:SetChecked(true)
        end
        myCheckButton:SetScript("OnClick",function(self)
            local checked = self:GetChecked()
            if checked == true then
                WeekKeysDB.Settings["pkeyslink"] = true
                evFrame:RegisterEvent("CHAT_MSG_PARTY")
                evFrame:RegisterEvent("CHAT_MSG_PARTY_LEADER")
            else
                WeekKeysDB.Settings["pkeyslink"] = false
                evFrame:UnregisterEvent("CHAT_MSG_PARTY")
                evFrame:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
            end
        end);

        local myCheckButton2 = CreateFrame("CheckButton", "WeekKeys_CheckButton2", arrayOfElements[1], "ChatConfigCheckButtonTemplate");
        myCheckButton2:SetPoint("TOPLEFT", 10, -35);
        WeekKeys_CheckButton2Text:SetText(L["hide_minimap"]);
        if WeekKeys.addon.db.profile.minimap.hide == true then
            myCheckButton2:SetChecked(true)
        end
        myCheckButton2:SetScript("OnClick",function(self)
            local checked = self:GetChecked()
            if checked == true then
                WeekKeys.addon.db.profile.minimap.hide = true
                WeekKeys.icon:Hide("WeekKeys")
            else
                WeekKeys.addon.db.profile.minimap.hide = false
                WeekKeys.icon:Show("WeekKeys")
               -- WeekKeys.addon.db.profile.minimap.minimapPos
            end
        end);


        WeekFrame:AddButton(L["settings"],arrayOfElements)
    end
end
